#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "libstemmer.h"

typedef struct sb_stemmer *psb_stemmer;

static int
not_here(char *s)
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(char *name, int arg)
{
    errno = 0;
    switch (*name) {
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

MODULE = Lingua::Stem::Snowball               PACKAGE = Lingua::Stem::Snowball


double
constant(name,arg)
        char *          name
        int             arg

PROTOTYPES: DISABLE


void
get_stemmer_list(out)
	SV *out;
	CODE:
	AV *ll = (AV*) SvRV(out);
	int i;
	const char ** names = sb_stemmer_list();
	char **ptr = (char **) names;

	while( *ptr ) {
		av_push(ll, newSVpv( *ptr, strlen(*ptr) ) );
		ptr++;
	}

	OUTPUT:
	out

psb_stemmer
stem_init( algorithm, charenc ) 
	char * algorithm
	char * charenc
	CODE:
	RETVAL = sb_stemmer_new(algorithm, charenc);
	OUTPUT:
	RETVAL

void
stem_close( stem )
	psb_stemmer	stem
	CODE:
	if ( stem )
		sb_stemmer_delete(stem);


int
do_stem(stem,word,lexem)
	psb_stemmer	 stem
	char *	word
	SV *	lexem
	CODE:
	int len = strlen(word);
	sb_symbol *win = (sb_symbol *)word;

	if ( !stem ) {
		RETVAL = -1;
	} else if ( len == 0 ) {
		RETVAL = -2;
	} else {
		int i;
		const sb_symbol	*wres;

		RETVAL = 0;
	
		for(i=0;i<len;i++)
			win[i] = tolower( (unsigned char)win[i] );

		wres = sb_stemmer_stem(stem, win, len);
		len = sb_stemmer_length(stem);

		sv_setpvn( lexem, wres, len ); 
	}
	OUTPUT:
	RETVAL
	lexem
